import { OnInit, TemplateRef, QueryList, EventEmitter } from '@angular/core';
import { NgForm } from '@angular/forms';
import { NgxCustomTemplateForDirective } from '../ngx-custom-template-for.directive';
import { CssInputModel } from '../reflect-input.models';
export declare class NgxFormForComponent implements OnInit {
    _model: any;
    set model(value: any);
    cssClasses: CssInputModel;
    autoComplete: string;
    form: NgForm;
    propertyNames: {
        field: string;
        template: boolean;
    }[];
    submitForm: EventEmitter<any>;
    _templates: NgxCustomTemplateForDirective[];
    set templates(value: QueryList<NgxCustomTemplateForDirective>);
    constructor();
    ngOnInit(): void;
    getTemplate(field: string): TemplateRef<any>;
    submit(): void;
}
