import { Injector } from '@angular/core';
import { AbstractControl, NgModel, ValidationErrors } from '@angular/forms';
import { ValueAccessorBase } from './value-accessor';
export declare abstract class ElementBase<T> extends ValueAccessorBase<T> {
    protected injector: Injector;
    protected abstract ngModel: NgModel;
    model: any;
    validator: (control: AbstractControl, dataModel: any) => ValidationErrors;
    constructor(injector: Injector);
    validate(control: AbstractControl): ValidationErrors;
}
