import { OnInit, ElementRef, TemplateRef, QueryList, Injector, EventEmitter } from '@angular/core';
import { NgModel, FormControlName } from '@angular/forms';
import { DataTypeEnum } from '../reflect-input.models';
import { NgxCustomTemplateForDirective } from '../ngx-custom-template-for.directive';
import { ElementBase } from '../element-base';
export declare class NgxInputForComponent extends ElementBase<any> implements OnInit {
    el: ElementRef;
    protected injector: Injector;
    DataTypeEnum: typeof DataTypeEnum;
    dataType: number;
    placeHolder: string;
    name: string;
    _template: NgxCustomTemplateForDirective;
    autocomplete: string;
    dataItems: any[];
    blurEvent: EventEmitter<any>;
    readonly: boolean;
    field: string;
    ngModel: NgModel;
    formControlName: FormControlName;
    ngxInput: boolean;
    onFocusout(): void;
    set templates(value: QueryList<NgxCustomTemplateForDirective>);
    constructor(el: ElementRef, injector: Injector);
    ngOnInit(): void;
    getTemplate(): TemplateRef<any>;
}
