import { ControlValueAccessor, NgControl } from '@angular/forms';
import { Injector } from '@angular/core';
export declare abstract class ValueAccessorBase<T> implements ControlValueAccessor {
    private theInjector;
    private innerValue;
    private onChange;
    private onTouch;
    disabled: boolean;
    private control;
    protected get formControl(): NgControl;
    get value(): T;
    set value(value: T);
    constructor(theInjector: Injector);
    writeValue(value: T): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(disabled: boolean): void;
    touch(): void;
}
